﻿using System.Text.Encodings.Web;
using System.Text.Json;

var jsonSerializerOptions = new JsonSerializerOptions
{
    WriteIndented = true,
};

Console.WriteLine("Default serialization (escaped quotes):");
Console.WriteLine(SerializeNestedObject(jsonSerializerOptions));

jsonSerializerOptions = new JsonSerializerOptions
{
    WriteIndented = true,
    Encoder = JavaScriptEncoder.UnsafeRelaxedJsonEscaping
};

Console.WriteLine("\n\nUnsafe serialization:");

Console.WriteLine(SerializeNestedObject(jsonSerializerOptions));

static string SerializeNestedObject(JsonSerializerOptions jsonSerializerOptions)
{
    var person = new Person()
    {
        Name = "Alan Adams",
        Age = 11
    };

    var message = new Message()
    {
        MessageId = Guid.NewGuid(),
        MessageBody = JsonSerializer.Serialize(person),
        MessageSource = "Somewhere",
        SentTimestamp = DateTime.Now.ToString(),
        SenderId = "12345"
    };

    QueueEvent queueEvent = new QueueEvent
    {
        Messages = new Message[] { message }
    };

    string serializedQueueEvent = JsonSerializer.Serialize(queueEvent, jsonSerializerOptions);
    
    return serializedQueueEvent;
}
